org.apache.commons.math3.distribution

## Class PoissonDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractIntegerDistribution
  - - org.apache.commons.math3.distribution.PoissonDistribution

- All Implemented Interfaces:
    Serializable, IntegerDistribution

      public class PoissonDistribution
      extends AbstractIntegerDistribution

  Implementation of the Poisson distribution.
  Version:
    $Id: PoissonDistribution.java 1244375 2012-02-15 06:30:05Z celestin $
  See Also:
    Poisson distribution (Wikipedia), Poisson distribution (MathWorld), Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static double` | `DEFAULT_EPSILON` Default convergence criterion.
    `static int` | `DEFAULT_MAX_ITERATIONS` Default maximum number of iterations for cumulative probability calculations.

    - ### Fields inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

      `randomData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PoissonDistribution(double p)` Creates a new Poisson distribution with specified mean.
    `PoissonDistribution(double p, double epsilon)` Creates a new Poisson distribution with the specified mean and convergence criterion.
    `PoissonDistribution(double p, double epsilon, int maxIterations)` Creates a new Poisson distribution with specified mean, convergence criterion and maximum number of iterations.
    `PoissonDistribution(double p, int maxIterations)` Creates a new Poisson distribution with the specified mean and maximum number of iterations.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `cumulativeProbability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
    `double` | `getMean()` Get the mean for the distribution.
    `double` | `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
    `double` | `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
    `int` | `getSupportLowerBound()` Access the lower bound of the support.
    `int` | `getSupportUpperBound()` Access the upper bound of the support.
    `boolean` | `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
    `double` | `normalApproximateProbability(int x)` Calculates the Poisson distribution function using a normal approximation.
    `double` | `probability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`.
    `int` | `sample()` Generate a random value sampled from this distribution.

    - ### Methods inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

      `cumulativeProbability, inverseCumulativeProbability, reseedRandomGenerator, sample, solveInverseCumulativeProbability`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_MAX_ITERATIONS

          public static final int DEFAULT_MAX_ITERATIONS

      Default maximum number of iterations for cumulative probability calculations.
      Since:
        2.1
      See Also:
        Constant Field Values

    - #### DEFAULT_EPSILON

          public static final double DEFAULT_EPSILON

      Default convergence criterion.
      Since:
        2.1
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PoissonDistribution

          public PoissonDistribution(double p)
                              throws NotStrictlyPositiveException

      Creates a new Poisson distribution with specified mean.
      Parameters:
        `p` - the Poisson mean
      Throws:
        `NotStrictlyPositiveException` - if `p <= 0`.

    - #### PoissonDistribution

          public PoissonDistribution(double p,
                             double epsilon,
                             int maxIterations)
                              throws NotStrictlyPositiveException

      Creates a new Poisson distribution with specified mean, convergence criterion and maximum number of iterations.
      Parameters:
        `p` - Poisson mean.
        `epsilon` - Convergence criterion for cumulative probabilities.
        `maxIterations` - the maximum number of iterations for cumulative probabilities.
      Throws:
        `NotStrictlyPositiveException` - if `p <= 0`.
      Since:
        2.1

    - #### PoissonDistribution

          public PoissonDistribution(double p,
                             double epsilon)
                              throws NotStrictlyPositiveException

      Creates a new Poisson distribution with the specified mean and convergence criterion.
      Parameters:
        `p` - Poisson mean.
        `epsilon` - Convergence criterion for cumulative probabilities.
      Throws:
        `NotStrictlyPositiveException` - if `p <= 0`.
      Since:
        2.1

    - #### PoissonDistribution

          public PoissonDistribution(double p,
                             int maxIterations)

      Creates a new Poisson distribution with the specified mean and maximum number of iterations.
      Parameters:
        `p` - Poisson mean.
        `maxIterations` - Maximum number of iterations for cumulative probabilities.
      Since:
        2.1

  - ### Method Detail

    - #### getMean

          public double getMean()

      Get the mean for the distribution.
      Returns:
        the mean for the distribution.

    - #### probability

          public double probability(int x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`. In other words, this method represents the probability mass function (PMF) for the distribution.
      Parameters:
        `x` - the point at which the PMF is evaluated
      Returns:
        the value of the probability mass function at `x`

    - #### cumulativeProbability

          public double cumulativeProbability(int x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.
      Parameters:
        `x` - the point at which the CDF is evaluated
      Returns:
        the probability that a random variable with this distribution takes a value less than or equal to `x`

    - #### normalApproximateProbability

          public double normalApproximateProbability(int x)

      Calculates the Poisson distribution function using a normal approximation. The `N(mean, sqrt(mean))` distribution is used to approximate the Poisson distribution. The computation uses "half-correction" (evaluating the normal distribution function at `x + 0.5`).
      Parameters:
        `x` - Upper bound, inclusive.
      Returns:
        the distribution function value calculated using a normal approximation.

    - #### getNumericalMean

          public double getNumericalMean()

      Use this method to get the numerical value of the mean of this distribution. For mean parameter `p`, the mean is `p`.
      Returns:
        the mean or `Double.NaN` if it is not defined

    - #### getNumericalVariance

          public double getNumericalVariance()

      Use this method to get the numerical value of the variance of this distribution. For mean parameter `p`, the variance is `p`.
      Returns:
        the variance (possibly `Double.POSITIVE_INFINITY` or `Double.NaN` if it is not defined)

    - #### getSupportLowerBound

          public int getSupportLowerBound()

      Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

      `inf {x in Z | P(X <= x) > 0}`.

      The lower bound of the support is always 0 no matter the mean parameter.
      Returns:
        lower bound of the support (always 0)

    - #### getSupportUpperBound

          public int getSupportUpperBound()

      Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

      `inf {x in R | P(X <= x) = 1}`.

      The upper bound of the support is positive infinity, regardless of the parameter values. There is no integer infinity, so this method returns `Integer.MAX_VALUE`.
      Returns:
        upper bound of the support (always `Integer.MAX_VALUE` for positive infinity)

    - #### isSupportConnected

          public boolean isSupportConnected()

      Use this method to get information about whether the support is connected, i.e. whether all integers between the lower and upper bound of the support are included in the support. The support of this distribution is connected.
      Returns:
        `true`

    - #### sample

          public int sample()

      Generate a random value sampled from this distribution. The default implementation uses the inversion method.

      Algorithm Description:

      - For small means, uses simulation of a Poisson process using Uniform deviates, as described here. The Poisson process (and hence value returned) is bounded by 1000 * mean.
      - For large means, uses the rejection algorithm described in Devroye, Luc. (1981).The Computer Generation of Poisson Random Variables Computing vol. 26 pp. 197-207.
      Specified by:
        `sample` in interface `IntegerDistribution`
      Overrides:
        `sample` in class `AbstractIntegerDistribution`
      Returns:
        a random value.
      Since:
        2.2

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.